EulerOS 2.0 SP3 : zsh (EulerOS-SA-2018-1396)

2018-12-10T00:00:00
ID EULEROS_SA-2018-1396.NASL
Type nessus
Reporter This script is Copyright (C) 2018-2020 and is owned by Tenable, Inc. or an Affiliate thereof.
Modified 2018-12-10T00:00:00

Description

According to the versions of the zsh package installed, the EulerOS installation on the remote host is affected by the following vulnerabilities :

  • zsh: buffer overflow for very long fds in i1/4zi1/4+ fd syntax (CVE-2014-10071)

  • zsh: buffer overflow when scanning very long directory paths for symbolic links (CVE-2014-10072)

  • zsh: NULL dereference in cd in sh compatibility mode under given circumstances (CVE-2017-18205)

  • zsh: buffer overrun in symlinks (CVE-2017-18206)

  • zsh: Stack-based buffer overflow in exec.c:hashcmd() (CVE-2018-1071)

  • zsh: buffer overflow in utils.c:checkmailpath() can lead to local arbitrary code execution (CVE-2018-1100)

  • zsh: crash on copying empty hash table (CVE-2018-7549)

Note that Tenable Network Security has extracted the preceding description block directly from the EulerOS security advisory. Tenable has attempted to automatically clean and format it as much as possible without introducing additional issues.

                                        
                                            #
# (C) Tenable Network Security, Inc.
#

include("compat.inc");

if (description)
{
  script_id(119524);
  script_version("1.5");
  script_set_attribute(attribute:"plugin_modification_date", value:"2020/05/13");

  script_cve_id(
    "CVE-2014-10071",
    "CVE-2014-10072",
    "CVE-2017-18205",
    "CVE-2017-18206",
    "CVE-2018-1071",
    "CVE-2018-1100",
    "CVE-2018-7549"
  );

  script_name(english:"EulerOS 2.0 SP3 : zsh (EulerOS-SA-2018-1396)");
  script_summary(english:"Checks the rpm output for the updated packages.");

  script_set_attribute(attribute:"synopsis", value:
"The remote EulerOS host is missing multiple security updates.");
  script_set_attribute(attribute:"description", value:
"According to the versions of the zsh package installed, the EulerOS
installation on the remote host is affected by the following
vulnerabilities :

  - zsh: buffer overflow for very long fds in i1/4zi1/4+ fd
    syntax (CVE-2014-10071)

  - zsh: buffer overflow when scanning very long directory
    paths for symbolic links (CVE-2014-10072)

  - zsh: NULL dereference in cd in sh compatibility mode
    under given circumstances (CVE-2017-18205)

  - zsh: buffer overrun in symlinks (CVE-2017-18206)

  - zsh: Stack-based buffer overflow in exec.c:hashcmd()
    (CVE-2018-1071)

  - zsh: buffer overflow in utils.c:checkmailpath() can
    lead to local arbitrary code execution (CVE-2018-1100)

  - zsh: crash on copying empty hash table (CVE-2018-7549)

Note that Tenable Network Security has extracted the preceding
description block directly from the EulerOS security advisory. Tenable
has attempted to automatically clean and format it as much as possible
without introducing additional issues.");
  # https://developer.huaweicloud.com/ict/en/site-euleros/euleros/security-advisories/EulerOS-SA-2018-1396
  script_set_attribute(attribute:"see_also", value:"http://www.nessus.org/u?12bcaee0");
  script_set_attribute(attribute:"solution", value:
"Update the affected zsh packages.");
  script_set_cvss_base_vector("CVSS2#AV:N/AC:L/Au:N/C:P/I:P/A:P");
  script_set_cvss_temporal_vector("CVSS2#E:U/RL:OF/RC:C");
  script_set_cvss3_base_vector("CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H");
  script_set_cvss3_temporal_vector("CVSS:3.0/E:U/RL:O/RC:C");
  script_set_attribute(attribute:"exploitability_ease", value:"No known exploits are available");

  script_set_attribute(attribute:"patch_publication_date", value:"2018/11/26");
  script_set_attribute(attribute:"plugin_publication_date", value:"2018/12/10");

  script_set_attribute(attribute:"plugin_type", value:"local");
  script_set_attribute(attribute:"cpe", value:"p-cpe:/a:huawei:euleros:zsh");
  script_set_attribute(attribute:"cpe", value:"cpe:/o:huawei:euleros:2.0");
  script_set_attribute(attribute:"generated_plugin", value:"current");
  script_end_attributes();

  script_category(ACT_GATHER_INFO);
  script_family(english:"Huawei Local Security Checks");

  script_copyright(english:"This script is Copyright (C) 2018-2020 and is owned by Tenable, Inc. or an Affiliate thereof.");

  script_dependencies("ssh_get_info.nasl");
  script_require_keys("Host/local_checks_enabled", "Host/EulerOS/release", "Host/EulerOS/rpm-list", "Host/EulerOS/sp");
  script_exclude_keys("Host/EulerOS/uvp_version");

  exit(0);
}

include("audit.inc");
include("global_settings.inc");
include("rpm.inc");

if (!get_kb_item("Host/local_checks_enabled")) audit(AUDIT_LOCAL_CHECKS_NOT_ENABLED);

release = get_kb_item("Host/EulerOS/release");
if (isnull(release) || release !~ "^EulerOS") audit(AUDIT_OS_NOT, "EulerOS");
if (release !~ "^EulerOS release 2\.0(\D|$)") audit(AUDIT_OS_NOT, "EulerOS 2.0");

sp = get_kb_item("Host/EulerOS/sp");
if (isnull(sp) || sp !~ "^(3)$") audit(AUDIT_OS_NOT, "EulerOS 2.0 SP3");

uvp = get_kb_item("Host/EulerOS/uvp_version");
if (!empty_or_null(uvp)) audit(AUDIT_OS_NOT, "EulerOS 2.0 SP3", "EulerOS UVP " + uvp);

if (!get_kb_item("Host/EulerOS/rpm-list")) audit(AUDIT_PACKAGE_LIST_MISSING);

cpu = get_kb_item("Host/cpu");
if (isnull(cpu)) audit(AUDIT_UNKNOWN_ARCH);
if ("x86_64" >!< cpu && cpu !~ "^i[3-6]86$" && "aarch64" >!< cpu) audit(AUDIT_LOCAL_CHECKS_NOT_IMPLEMENTED, "EulerOS", cpu);
if ("x86_64" >!< cpu && cpu !~ "^i[3-6]86$") audit(AUDIT_ARCH_NOT, "i686 / x86_64", cpu);

flag = 0;

pkgs = ["zsh-5.0.2-31.h1"];

foreach (pkg in pkgs)
  if (rpm_check(release:"EulerOS-2.0", sp:"3", reference:pkg)) flag++;

if (flag)
{
  security_report_v4(
    port       : 0,
    severity   : SECURITY_HOLE,
    extra      : rpm_report_get()
  );
  exit(0);
}
else
{
  tested = pkg_tests_get();
  if (tested) audit(AUDIT_PACKAGE_NOT_AFFECTED, tested);
  else audit(AUDIT_PACKAGE_NOT_INSTALLED, "zsh");
}